import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import java.util.*;
import javax.activation.*;


public class MailFile {
  private String to;
  private String from;
  private String text;
  private String subject;
  private String server;
  private String file;

  public void MailFile(){
  }
  private void printErr(String str){
    System.out.println("\n - MailFile  -  Simple mail with MIME file attachment command line utility. - ");
    System.out.println("Copyright (c) 2000, Johan Akerstrom, 25 May 2000, johan.akerstrom@cosmoskey.com");
    System.out.println("\nUsage:");
    System.out.print("MailFile to-addr from-addr subject ");
    System.out.println("text server file");
    System.out.println("\nSample:");
    System.out.print("MailFile admin@domain.com mailfile@domain.com ");
    System.out.println("\"Log file from server FS1\"");
    System.out.print("         \"There are a attached file\" ");
    System.out.println("smtp.domain.com [sys:/etc/console.log]");
    System.out.println("\n"+str+"\n");
  }
  private void run(String[] args){
    if(args.length == 5||args.length == 6){
      to      = args[0];
      from    = args[1];
      subject = args[2];
      text    = args[3];
      server  = args[4];
      if (args.length == 6)file = args[5];
    }
    else {
      try{
        Runtime.getRuntime().exec("CLS");
      } catch (Exception e){}
      printErr("");
      System.exit(0);
    }
    System.out.println("  - MailFile  -  Simple mail with MIME file attachment command line utility. -  ");
    System.out.println("Copyright (c) 2000, Johan Akerstrom, 25 May 2000 - johan.akerstrom@cosmoskey.com\n");
    System.out.println("To     :"+to);
    System.out.println("From   :"+from);
    System.out.println("Subject:"+subject);
    System.out.println("Text   :"+text);
    System.out.println("Server :"+server);
    if(file != null)System.out.println("File   :"+file);
    else System.out.println("File   : <No file attached>");
    try{
      Properties properties = System.getProperties();
      properties.put("mail.smtp.host", server);
      Session session = Session.getInstance(properties, null);
      MimeMessage message = new MimeMessage(session);
      Address fromAddress = new InternetAddress(from);
      message.setFrom(fromAddress);
      Address[] toAddresses = InternetAddress.parse(to);
      message.setRecipients(Message.RecipientType.TO, toAddresses);
      message.setSubject(subject);
      MimeBodyPart mbp1 = new MimeBodyPart();
      mbp1.setText(text);
      Multipart mp = new MimeMultipart();
      mp.addBodyPart(mbp1);
      if (file != null){
        MimeBodyPart mbp2 = new MimeBodyPart();
        FileDataSource fds = new FileDataSource(file);
        mbp2.setDataHandler(new DataHandler(fds));
        mbp2.setFileName(file);
        mp.addBodyPart(mbp2);
      }
      message.setContent(mp);
      System.out.println("");
      System.out.println("Sending...");
      Transport.send(message);
      System.out.println("Sent!!!\n\n");
    }
    catch (AddressException ae) {
      printErr("--- Error ---\nCheck e-mail addresses");
      System.exit(1);
    }
    catch (SendFailedException sfe) {
      printErr("--- Error ---\nCheck Filename or SMTP Server address");
      System.exit(2);
    }
    catch (MessagingException me) {
      printErr("--- Error ---\nSomething is wrong");
      System.exit(3);
    }
  }
  public static void main(String[] args){
    MailFile mf = new MailFile();
    mf.run(args);
  }
}
